/* boni.c generated by valac 0.48.13, the Vala compiler
 * generated from boni.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*-
 * Gnome Nibbles: Gnome Worm Game
 * Copyright (C) 2015 Iulian-Gabriel Radu <iulian.radu67@gmail.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
/* This is a fairly literal translation of the GPLv2+ original by*/
/* Sean MacIsaac, Ian Peters, Guillaume Béland.*/

#include <glib-object.h>
#include <glib.h>
#include <gee.h>

typedef enum  {
	BONUS_TYPE_REGULAR,
	BONUS_TYPE_HALF,
	BONUS_TYPE_DOUBLE,
	BONUS_TYPE_LIFE,
	BONUS_TYPE_REVERSE,
	BONUS_TYPE_WARP
} BonusType;

#define TYPE_BONUS_TYPE (bonus_type_get_type ())

#define TYPE_BONUS (bonus_get_type ())
#define BONUS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BONUS, Bonus))
#define BONUS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BONUS, BonusClass))
#define IS_BONUS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BONUS))
#define IS_BONUS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BONUS))
#define BONUS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BONUS, BonusClass))

typedef struct _Bonus Bonus;
typedef struct _BonusClass BonusClass;
typedef struct _BonusPrivate BonusPrivate;
enum  {
	BONUS_0_PROPERTY,
	BONUS_X_PROPERTY,
	BONUS_Y_PROPERTY,
	BONUS_BONUS_TYPE_PROPERTY,
	BONUS_FAKE_PROPERTY,
	BONUS_COUNTDOWN_PROPERTY,
	BONUS_NUM_PROPERTIES
};
static GParamSpec* bonus_properties[BONUS_NUM_PROPERTIES];

#define TYPE_BONI (boni_get_type ())
#define BONI(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BONI, Boni))
#define BONI_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BONI, BoniClass))
#define IS_BONI(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BONI))
#define IS_BONI_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BONI))
#define BONI_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BONI, BoniClass))

typedef struct _Boni Boni;
typedef struct _BoniClass BoniClass;
typedef struct _BoniPrivate BoniPrivate;
enum  {
	BONI_0_PROPERTY,
	BONI_NUM_PROPERTIES
};
static GParamSpec* boni_properties[BONI_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
enum  {
	BONI_BONUS_REMOVED_SIGNAL,
	BONI_NUM_SIGNALS
};
static guint boni_signals[BONI_NUM_SIGNALS] = {0};

struct _Bonus {
	GObject parent_instance;
	BonusPrivate * priv;
};

struct _BonusClass {
	GObjectClass parent_class;
};

struct _BonusPrivate {
	guint8 _x;
	guint8 _y;
	BonusType _bonus_type;
	gboolean _fake;
	guint16 _countdown;
};

struct _Boni {
	GObject parent_instance;
	BoniPrivate * priv;
};

struct _BoniClass {
	GObjectClass parent_class;
};

struct _BoniPrivate {
	GeeLinkedList* bonuses;
	guint8 regular_bonus_left;
	guint8 regular_bonus_maxi;
	guint8 total_bonus_number;
	guint8 missed;
};

static gint Bonus_private_offset;
static gpointer bonus_parent_class = NULL;
static gint Boni_private_offset;
static gpointer boni_parent_class = NULL;

GType bonus_type_get_type (void) G_GNUC_CONST;
GType bonus_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Bonus, g_object_unref)
Bonus* bonus_new (guint8 x,
                  guint8 y,
                  BonusType bonus_type,
                  gboolean fake,
                  guint16 countdown);
Bonus* bonus_construct (GType object_type,
                        guint8 x,
                        guint8 y,
                        BonusType bonus_type,
                        gboolean fake,
                        guint16 countdown);
guint8 bonus_get_x (Bonus* self);
static void bonus_set_x (Bonus* self,
                  guint8 value);
guint8 bonus_get_y (Bonus* self);
static void bonus_set_y (Bonus* self,
                  guint8 value);
BonusType bonus_get_bonus_type (Bonus* self);
static void bonus_set_bonus_type (Bonus* self,
                           BonusType value);
gboolean bonus_get_fake (Bonus* self);
static void bonus_set_fake (Bonus* self,
                     gboolean value);
guint16 bonus_get_countdown (Bonus* self);
void bonus_set_countdown (Bonus* self,
                          guint16 value);
static void bonus_finalize (GObject * obj);
static GType bonus_get_type_once (void);
static void _vala_bonus_get_property (GObject * object,
                               guint property_id,
                               GValue * value,
                               GParamSpec * pspec);
static void _vala_bonus_set_property (GObject * object,
                               guint property_id,
                               const GValue * value,
                               GParamSpec * pspec);
GType boni_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Boni, g_object_unref)
#define BONI_MAX_BONUSES ((guint8) 100)
#define BONI_MAX_MISSED ((guint8) 2)
gboolean boni_add_bonus (Boni* self,
                         gint* board,
                         gint board_length1,
                         gint board_length2,
                         Bonus* bonus);
void boni_remove_bonus (Boni* self,
                        gint* board,
                        gint board_length1,
                        gint board_length2,
                        Bonus* bonus);
#define NIBBLES_GAME_EMPTYCHAR 'a'
void boni_reset (Boni* self,
                 guint8 regular_bonus);
static inline void boni_reset_missed (Boni* self);
Bonus* boni_get_bonus (Boni* self,
                       gint* board,
                       gint board_length1,
                       gint board_length2,
                       guint8 x,
                       guint8 y);
void boni_on_worms_move (Boni* self,
                         gint* board,
                         gint board_length1,
                         gint board_length2,
                         guint8* missed_bonuses_to_replace);
static inline void boni_increase_missed (Boni* self);
guint8 boni_new_regular_bonus_eaten (Boni* self);
gboolean boni_last_regular_bonus (Boni* self);
gboolean boni_too_many_missed (Boni* self);
Boni* boni_new (void);
Boni* boni_construct (GType object_type);
static void boni_finalize (GObject * obj);
static GType boni_get_type_once (void);

static GType
bonus_type_get_type_once (void)
{
	static const GEnumValue values[] = {{BONUS_TYPE_REGULAR, "BONUS_TYPE_REGULAR", "regular"}, {BONUS_TYPE_HALF, "BONUS_TYPE_HALF", "half"}, {BONUS_TYPE_DOUBLE, "BONUS_TYPE_DOUBLE", "double"}, {BONUS_TYPE_LIFE, "BONUS_TYPE_LIFE", "life"}, {BONUS_TYPE_REVERSE, "BONUS_TYPE_REVERSE", "reverse"}, {BONUS_TYPE_WARP, "BONUS_TYPE_WARP", "warp"}, {0, NULL, NULL}};
	GType bonus_type_type_id;
	bonus_type_type_id = g_enum_register_static ("BonusType", values);
	return bonus_type_type_id;
}

GType
bonus_type_get_type (void)
{
	static volatile gsize bonus_type_type_id__volatile = 0;
	if (g_once_init_enter (&bonus_type_type_id__volatile)) {
		GType bonus_type_type_id;
		bonus_type_type_id = bonus_type_get_type_once ();
		g_once_init_leave (&bonus_type_type_id__volatile, bonus_type_type_id);
	}
	return bonus_type_type_id__volatile;
}

static inline gpointer
bonus_get_instance_private (Bonus* self)
{
	return G_STRUCT_MEMBER_P (self, Bonus_private_offset);
}

Bonus*
bonus_construct (GType object_type,
                 guint8 x,
                 guint8 y,
                 BonusType bonus_type,
                 gboolean fake,
                 guint16 countdown)
{
	Bonus * self = NULL;
	self = (Bonus*) g_object_new (object_type, "x", x, "y", y, "bonus-type", bonus_type, "fake", fake, "countdown", countdown, NULL);
	return self;
}

Bonus*
bonus_new (guint8 x,
           guint8 y,
           BonusType bonus_type,
           gboolean fake,
           guint16 countdown)
{
	return bonus_construct (TYPE_BONUS, x, y, bonus_type, fake, countdown);
}

guint8
bonus_get_x (Bonus* self)
{
	guint8 result;
	g_return_val_if_fail (self != NULL, 0U);
	result = self->priv->_x;
	return result;
}

static void
bonus_set_x (Bonus* self,
             guint8 value)
{
	guint8 old_value;
	g_return_if_fail (self != NULL);
	old_value = bonus_get_x (self);
	if (old_value != value) {
		self->priv->_x = value;
		g_object_notify_by_pspec ((GObject *) self, bonus_properties[BONUS_X_PROPERTY]);
	}
}

guint8
bonus_get_y (Bonus* self)
{
	guint8 result;
	g_return_val_if_fail (self != NULL, 0U);
	result = self->priv->_y;
	return result;
}

static void
bonus_set_y (Bonus* self,
             guint8 value)
{
	guint8 old_value;
	g_return_if_fail (self != NULL);
	old_value = bonus_get_y (self);
	if (old_value != value) {
		self->priv->_y = value;
		g_object_notify_by_pspec ((GObject *) self, bonus_properties[BONUS_Y_PROPERTY]);
	}
}

BonusType
bonus_get_bonus_type (Bonus* self)
{
	BonusType result;
	BonusType _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_bonus_type;
	result = _tmp0_;
	return result;
}

static void
bonus_set_bonus_type (Bonus* self,
                      BonusType value)
{
	BonusType old_value;
	g_return_if_fail (self != NULL);
	old_value = bonus_get_bonus_type (self);
	if (old_value != value) {
		self->priv->_bonus_type = value;
		g_object_notify_by_pspec ((GObject *) self, bonus_properties[BONUS_BONUS_TYPE_PROPERTY]);
	}
}

gboolean
bonus_get_fake (Bonus* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_fake;
	return result;
}

static void
bonus_set_fake (Bonus* self,
                gboolean value)
{
	gboolean old_value;
	g_return_if_fail (self != NULL);
	old_value = bonus_get_fake (self);
	if (old_value != value) {
		self->priv->_fake = value;
		g_object_notify_by_pspec ((GObject *) self, bonus_properties[BONUS_FAKE_PROPERTY]);
	}
}

guint16
bonus_get_countdown (Bonus* self)
{
	guint16 result;
	g_return_val_if_fail (self != NULL, 0U);
	result = self->priv->_countdown;
	return result;
}

void
bonus_set_countdown (Bonus* self,
                     guint16 value)
{
	guint16 old_value;
	g_return_if_fail (self != NULL);
	old_value = bonus_get_countdown (self);
	if (old_value != value) {
		self->priv->_countdown = value;
		g_object_notify_by_pspec ((GObject *) self, bonus_properties[BONUS_COUNTDOWN_PROPERTY]);
	}
}

static void
bonus_class_init (BonusClass * klass,
                  gpointer klass_data)
{
	bonus_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &Bonus_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_bonus_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_bonus_set_property;
	G_OBJECT_CLASS (klass)->finalize = bonus_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), BONUS_X_PROPERTY, bonus_properties[BONUS_X_PROPERTY] = g_param_spec_uchar ("x", "x", "x", 0, G_MAXUINT8, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), BONUS_Y_PROPERTY, bonus_properties[BONUS_Y_PROPERTY] = g_param_spec_uchar ("y", "y", "y", 0, G_MAXUINT8, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), BONUS_BONUS_TYPE_PROPERTY, bonus_properties[BONUS_BONUS_TYPE_PROPERTY] = g_param_spec_enum ("bonus-type", "bonus-type", "bonus-type", TYPE_BONUS_TYPE, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), BONUS_FAKE_PROPERTY, bonus_properties[BONUS_FAKE_PROPERTY] = g_param_spec_boolean ("fake", "fake", "fake", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), BONUS_COUNTDOWN_PROPERTY, bonus_properties[BONUS_COUNTDOWN_PROPERTY] = g_param_spec_uint ("countdown", "countdown", "countdown", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
}

static void
bonus_instance_init (Bonus * self,
                     gpointer klass)
{
	self->priv = bonus_get_instance_private (self);
}

static void
bonus_finalize (GObject * obj)
{
	Bonus * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_BONUS, Bonus);
	G_OBJECT_CLASS (bonus_parent_class)->finalize (obj);
}

static GType
bonus_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (BonusClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) bonus_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Bonus), 0, (GInstanceInitFunc) bonus_instance_init, NULL };
	GType bonus_type_id;
	bonus_type_id = g_type_register_static (G_TYPE_OBJECT, "Bonus", &g_define_type_info, 0);
	Bonus_private_offset = g_type_add_instance_private (bonus_type_id, sizeof (BonusPrivate));
	return bonus_type_id;
}

GType
bonus_get_type (void)
{
	static volatile gsize bonus_type_id__volatile = 0;
	if (g_once_init_enter (&bonus_type_id__volatile)) {
		GType bonus_type_id;
		bonus_type_id = bonus_get_type_once ();
		g_once_init_leave (&bonus_type_id__volatile, bonus_type_id);
	}
	return bonus_type_id__volatile;
}

static void
_vala_bonus_get_property (GObject * object,
                          guint property_id,
                          GValue * value,
                          GParamSpec * pspec)
{
	Bonus * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_BONUS, Bonus);
	switch (property_id) {
		case BONUS_X_PROPERTY:
		g_value_set_uchar (value, bonus_get_x (self));
		break;
		case BONUS_Y_PROPERTY:
		g_value_set_uchar (value, bonus_get_y (self));
		break;
		case BONUS_BONUS_TYPE_PROPERTY:
		g_value_set_enum (value, bonus_get_bonus_type (self));
		break;
		case BONUS_FAKE_PROPERTY:
		g_value_set_boolean (value, bonus_get_fake (self));
		break;
		case BONUS_COUNTDOWN_PROPERTY:
		g_value_set_uint (value, bonus_get_countdown (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_bonus_set_property (GObject * object,
                          guint property_id,
                          const GValue * value,
                          GParamSpec * pspec)
{
	Bonus * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_BONUS, Bonus);
	switch (property_id) {
		case BONUS_X_PROPERTY:
		bonus_set_x (self, g_value_get_uchar (value));
		break;
		case BONUS_Y_PROPERTY:
		bonus_set_y (self, g_value_get_uchar (value));
		break;
		case BONUS_BONUS_TYPE_PROPERTY:
		bonus_set_bonus_type (self, g_value_get_enum (value));
		break;
		case BONUS_FAKE_PROPERTY:
		bonus_set_fake (self, g_value_get_boolean (value));
		break;
		case BONUS_COUNTDOWN_PROPERTY:
		bonus_set_countdown (self, g_value_get_uint (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static inline gpointer
boni_get_instance_private (Boni* self)
{
	return G_STRUCT_MEMBER_P (self, Boni_private_offset);
}

gboolean
boni_add_bonus (Boni* self,
                gint* board,
                gint board_length1,
                gint board_length2,
                Bonus* bonus)
{
	GeeLinkedList* _tmp0_;
	guint8 _tmp1_;
	guint8 _tmp2_;
	guint8 _tmp3_;
	guint8 _tmp4_;
	BonusType _tmp5_;
	BonusType _tmp6_;
	guint8 _tmp7_;
	guint8 _tmp8_;
	guint8 _tmp9_;
	guint8 _tmp10_;
	BonusType _tmp11_;
	BonusType _tmp12_;
	guint8 _tmp13_;
	guint8 _tmp14_;
	guint8 _tmp15_;
	guint8 _tmp16_;
	BonusType _tmp17_;
	BonusType _tmp18_;
	guint8 _tmp19_;
	guint8 _tmp20_;
	guint8 _tmp21_;
	guint8 _tmp22_;
	BonusType _tmp23_;
	BonusType _tmp24_;
	guint8 _tmp25_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (bonus != NULL, FALSE);
	if (self->priv->total_bonus_number >= BONI_MAX_BONUSES) {
		result = FALSE;
		_g_object_unref0 (bonus);
		return result;
	}
	_tmp0_ = self->priv->bonuses;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp0_, bonus);
	_tmp1_ = bonus_get_x (bonus);
	_tmp2_ = _tmp1_;
	_tmp3_ = bonus_get_y (bonus);
	_tmp4_ = _tmp3_;
	_tmp5_ = bonus_get_bonus_type (bonus);
	_tmp6_ = _tmp5_;
	board[(_tmp2_ * board_length2) + _tmp4_] = (gint) (_tmp6_ + 'A');
	_tmp7_ = bonus_get_x (bonus);
	_tmp8_ = _tmp7_;
	_tmp9_ = bonus_get_y (bonus);
	_tmp10_ = _tmp9_;
	_tmp11_ = bonus_get_bonus_type (bonus);
	_tmp12_ = _tmp11_;
	board[((_tmp8_ + 1) * board_length2) + _tmp10_] = (gint) (_tmp12_ + 'A');
	_tmp13_ = bonus_get_x (bonus);
	_tmp14_ = _tmp13_;
	_tmp15_ = bonus_get_y (bonus);
	_tmp16_ = _tmp15_;
	_tmp17_ = bonus_get_bonus_type (bonus);
	_tmp18_ = _tmp17_;
	board[(_tmp14_ * board_length2) + (_tmp16_ + 1)] = (gint) (_tmp18_ + 'A');
	_tmp19_ = bonus_get_x (bonus);
	_tmp20_ = _tmp19_;
	_tmp21_ = bonus_get_y (bonus);
	_tmp22_ = _tmp21_;
	_tmp23_ = bonus_get_bonus_type (bonus);
	_tmp24_ = _tmp23_;
	board[((_tmp20_ + 1) * board_length2) + (_tmp22_ + 1)] = (gint) (_tmp24_ + 'A');
	_tmp25_ = self->priv->total_bonus_number;
	self->priv->total_bonus_number = _tmp25_ + 1;
	result = TRUE;
	_g_object_unref0 (bonus);
	return result;
}

void
boni_remove_bonus (Boni* self,
                   gint* board,
                   gint board_length1,
                   gint board_length2,
                   Bonus* bonus)
{
	guint8 _tmp0_;
	guint8 _tmp1_;
	guint8 _tmp2_;
	guint8 _tmp3_;
	guint8 _tmp4_;
	guint8 _tmp5_;
	guint8 _tmp6_;
	guint8 _tmp7_;
	guint8 _tmp8_;
	guint8 _tmp9_;
	guint8 _tmp10_;
	guint8 _tmp11_;
	guint8 _tmp12_;
	guint8 _tmp13_;
	guint8 _tmp14_;
	guint8 _tmp15_;
	GeeLinkedList* _tmp16_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (bonus != NULL);
	_tmp0_ = bonus_get_x (bonus);
	_tmp1_ = _tmp0_;
	_tmp2_ = bonus_get_y (bonus);
	_tmp3_ = _tmp2_;
	board[(_tmp1_ * board_length2) + _tmp3_] = (gint) NIBBLES_GAME_EMPTYCHAR;
	_tmp4_ = bonus_get_x (bonus);
	_tmp5_ = _tmp4_;
	_tmp6_ = bonus_get_y (bonus);
	_tmp7_ = _tmp6_;
	board[((_tmp5_ + 1) * board_length2) + _tmp7_] = (gint) NIBBLES_GAME_EMPTYCHAR;
	_tmp8_ = bonus_get_x (bonus);
	_tmp9_ = _tmp8_;
	_tmp10_ = bonus_get_y (bonus);
	_tmp11_ = _tmp10_;
	board[(_tmp9_ * board_length2) + (_tmp11_ + 1)] = (gint) NIBBLES_GAME_EMPTYCHAR;
	_tmp12_ = bonus_get_x (bonus);
	_tmp13_ = _tmp12_;
	_tmp14_ = bonus_get_y (bonus);
	_tmp15_ = _tmp14_;
	board[((_tmp13_ + 1) * board_length2) + (_tmp15_ + 1)] = (gint) NIBBLES_GAME_EMPTYCHAR;
	g_signal_emit (self, boni_signals[BONI_BONUS_REMOVED_SIGNAL], 0, bonus);
	_tmp16_ = self->priv->bonuses;
	gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp16_, bonus);
}

void
boni_reset (Boni* self,
            guint8 regular_bonus)
{
	GeeLinkedList* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->bonuses;
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp0_);
	boni_reset_missed (self);
	self->priv->regular_bonus_maxi = regular_bonus;
	self->priv->regular_bonus_left = regular_bonus;
	self->priv->total_bonus_number = (guint8) 0;
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

Bonus*
boni_get_bonus (Boni* self,
                gint* board,
                gint board_length1,
                gint board_length2,
                guint8 x,
                guint8 y)
{
	Bonus* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	{
		GeeLinkedList* _bonus_list = NULL;
		GeeLinkedList* _tmp0_;
		GeeLinkedList* _tmp1_;
		gint _bonus_size = 0;
		GeeLinkedList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _bonus_index = 0;
		_tmp0_ = self->priv->bonuses;
		_tmp1_ = _g_object_ref0 (_tmp0_);
		_bonus_list = _tmp1_;
		_tmp2_ = _bonus_list;
		_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp2_);
		_tmp4_ = _tmp3_;
		_bonus_size = _tmp4_;
		_bonus_index = -1;
		while (TRUE) {
			gint _tmp5_;
			gint _tmp6_;
			Bonus* bonus = NULL;
			GeeLinkedList* _tmp7_;
			gpointer _tmp8_;
			gboolean _tmp9_ = FALSE;
			gboolean _tmp10_ = FALSE;
			gboolean _tmp11_ = FALSE;
			gboolean _tmp12_ = FALSE;
			Bonus* _tmp13_;
			guint8 _tmp14_;
			guint8 _tmp15_;
			_bonus_index = _bonus_index + 1;
			_tmp5_ = _bonus_index;
			_tmp6_ = _bonus_size;
			if (!(_tmp5_ < _tmp6_)) {
				break;
			}
			_tmp7_ = _bonus_list;
			_tmp8_ = gee_abstract_list_get ((GeeAbstractList*) _tmp7_, _bonus_index);
			bonus = (Bonus*) _tmp8_;
			_tmp13_ = bonus;
			_tmp14_ = bonus_get_x (_tmp13_);
			_tmp15_ = _tmp14_;
			if (x == _tmp15_) {
				Bonus* _tmp16_;
				guint8 _tmp17_;
				guint8 _tmp18_;
				_tmp16_ = bonus;
				_tmp17_ = bonus_get_y (_tmp16_);
				_tmp18_ = _tmp17_;
				_tmp12_ = y == _tmp18_;
			} else {
				_tmp12_ = FALSE;
			}
			if (_tmp12_) {
				_tmp11_ = TRUE;
			} else {
				gboolean _tmp19_ = FALSE;
				Bonus* _tmp20_;
				guint8 _tmp21_;
				guint8 _tmp22_;
				_tmp20_ = bonus;
				_tmp21_ = bonus_get_x (_tmp20_);
				_tmp22_ = _tmp21_;
				if (((gint) x) == (_tmp22_ + 1)) {
					Bonus* _tmp23_;
					guint8 _tmp24_;
					guint8 _tmp25_;
					_tmp23_ = bonus;
					_tmp24_ = bonus_get_y (_tmp23_);
					_tmp25_ = _tmp24_;
					_tmp19_ = y == _tmp25_;
				} else {
					_tmp19_ = FALSE;
				}
				_tmp11_ = _tmp19_;
			}
			if (_tmp11_) {
				_tmp10_ = TRUE;
			} else {
				gboolean _tmp26_ = FALSE;
				Bonus* _tmp27_;
				guint8 _tmp28_;
				guint8 _tmp29_;
				_tmp27_ = bonus;
				_tmp28_ = bonus_get_x (_tmp27_);
				_tmp29_ = _tmp28_;
				if (x == _tmp29_) {
					Bonus* _tmp30_;
					guint8 _tmp31_;
					guint8 _tmp32_;
					_tmp30_ = bonus;
					_tmp31_ = bonus_get_y (_tmp30_);
					_tmp32_ = _tmp31_;
					_tmp26_ = ((gint) y) == (_tmp32_ + 1);
				} else {
					_tmp26_ = FALSE;
				}
				_tmp10_ = _tmp26_;
			}
			if (_tmp10_) {
				_tmp9_ = TRUE;
			} else {
				gboolean _tmp33_ = FALSE;
				Bonus* _tmp34_;
				guint8 _tmp35_;
				guint8 _tmp36_;
				_tmp34_ = bonus;
				_tmp35_ = bonus_get_x (_tmp34_);
				_tmp36_ = _tmp35_;
				if (((gint) x) == (_tmp36_ + 1)) {
					Bonus* _tmp37_;
					guint8 _tmp38_;
					guint8 _tmp39_;
					_tmp37_ = bonus;
					_tmp38_ = bonus_get_y (_tmp37_);
					_tmp39_ = _tmp38_;
					_tmp33_ = ((gint) y) == (_tmp39_ + 1);
				} else {
					_tmp33_ = FALSE;
				}
				_tmp9_ = _tmp33_;
			}
			if (_tmp9_) {
				result = bonus;
				_g_object_unref0 (_bonus_list);
				return result;
			}
			_g_object_unref0 (bonus);
		}
		_g_object_unref0 (_bonus_list);
	}
	result = NULL;
	return result;
}

void
boni_on_worms_move (Boni* self,
                    gint* board,
                    gint board_length1,
                    gint board_length2,
                    guint8* missed_bonuses_to_replace)
{
	guint8 _vala_missed_bonuses_to_replace = 0U;
	GeeLinkedList* found = NULL;
	GeeLinkedList* _tmp0_;
	g_return_if_fail (self != NULL);
	_vala_missed_bonuses_to_replace = (guint8) 0;
	_tmp0_ = gee_linked_list_new (TYPE_BONUS, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	found = _tmp0_;
	{
		GeeLinkedList* _bonus_list = NULL;
		GeeLinkedList* _tmp1_;
		GeeLinkedList* _tmp2_;
		gint _bonus_size = 0;
		GeeLinkedList* _tmp3_;
		gint _tmp4_;
		gint _tmp5_;
		gint _bonus_index = 0;
		_tmp1_ = self->priv->bonuses;
		_tmp2_ = _g_object_ref0 (_tmp1_);
		_bonus_list = _tmp2_;
		_tmp3_ = _bonus_list;
		_tmp4_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp3_);
		_tmp5_ = _tmp4_;
		_bonus_size = _tmp5_;
		_bonus_index = -1;
		while (TRUE) {
			gint _tmp6_;
			gint _tmp7_;
			Bonus* bonus = NULL;
			GeeLinkedList* _tmp8_;
			gpointer _tmp9_;
			Bonus* _tmp10_;
			guint16 _tmp11_;
			guint16 _tmp12_;
			_bonus_index = _bonus_index + 1;
			_tmp6_ = _bonus_index;
			_tmp7_ = _bonus_size;
			if (!(_tmp6_ < _tmp7_)) {
				break;
			}
			_tmp8_ = _bonus_list;
			_tmp9_ = gee_abstract_list_get ((GeeAbstractList*) _tmp8_, _bonus_index);
			bonus = (Bonus*) _tmp9_;
			_tmp10_ = bonus;
			_tmp11_ = bonus_get_countdown (_tmp10_);
			_tmp12_ = _tmp11_;
			if (((gint) _tmp12_) == 0) {
				GeeLinkedList* _tmp13_;
				Bonus* _tmp14_;
				_tmp13_ = found;
				_tmp14_ = bonus;
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp13_, _tmp14_);
			} else {
				Bonus* _tmp15_;
				guint16 _tmp16_;
				guint16 _tmp17_;
				_tmp15_ = bonus;
				_tmp16_ = bonus_get_countdown (_tmp15_);
				_tmp17_ = _tmp16_;
				bonus_set_countdown (_tmp15_, _tmp17_ - 1);
			}
			_g_object_unref0 (bonus);
		}
		_g_object_unref0 (_bonus_list);
	}
	{
		GeeLinkedList* _bonus_list = NULL;
		GeeLinkedList* _tmp18_;
		GeeLinkedList* _tmp19_;
		gint _bonus_size = 0;
		GeeLinkedList* _tmp20_;
		gint _tmp21_;
		gint _tmp22_;
		gint _bonus_index = 0;
		_tmp18_ = found;
		_tmp19_ = _g_object_ref0 (_tmp18_);
		_bonus_list = _tmp19_;
		_tmp20_ = _bonus_list;
		_tmp21_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp20_);
		_tmp22_ = _tmp21_;
		_bonus_size = _tmp22_;
		_bonus_index = -1;
		while (TRUE) {
			gint _tmp23_;
			gint _tmp24_;
			Bonus* bonus = NULL;
			GeeLinkedList* _tmp25_;
			gpointer _tmp26_;
			gboolean _tmp27_ = FALSE;
			Bonus* _tmp28_;
			BonusType _tmp29_;
			BonusType _tmp30_;
			gboolean real_bonus = FALSE;
			Bonus* _tmp34_;
			_bonus_index = _bonus_index + 1;
			_tmp23_ = _bonus_index;
			_tmp24_ = _bonus_size;
			if (!(_tmp23_ < _tmp24_)) {
				break;
			}
			_tmp25_ = _bonus_list;
			_tmp26_ = gee_abstract_list_get ((GeeAbstractList*) _tmp25_, _bonus_index);
			bonus = (Bonus*) _tmp26_;
			_tmp28_ = bonus;
			_tmp29_ = bonus_get_bonus_type (_tmp28_);
			_tmp30_ = _tmp29_;
			if (_tmp30_ == BONUS_TYPE_REGULAR) {
				Bonus* _tmp31_;
				gboolean _tmp32_;
				gboolean _tmp33_;
				_tmp31_ = bonus;
				_tmp32_ = bonus_get_fake (_tmp31_);
				_tmp33_ = _tmp32_;
				_tmp27_ = !_tmp33_;
			} else {
				_tmp27_ = FALSE;
			}
			real_bonus = _tmp27_;
			_tmp34_ = bonus;
			boni_remove_bonus (self, board, (gint) board_length1, (gint) board_length2, _tmp34_);
			if (real_bonus) {
				guint8 _tmp35_;
				boni_increase_missed (self);
				_tmp35_ = _vala_missed_bonuses_to_replace;
				_vala_missed_bonuses_to_replace = _tmp35_ + 1;
			}
			_g_object_unref0 (bonus);
		}
		_g_object_unref0 (_bonus_list);
	}
	_g_object_unref0 (found);
	if (missed_bonuses_to_replace) {
		*missed_bonuses_to_replace = _vala_missed_bonuses_to_replace;
	}
}

inline guint8
boni_new_regular_bonus_eaten (Boni* self)
{
	guint8 _tmp0_;
	guint8 result = 0U;
	g_return_val_if_fail (self != NULL, 0U);
	if (((gint) self->priv->regular_bonus_left) == 0) {
		g_assert_not_reached ();
	}
	_tmp0_ = self->priv->regular_bonus_left;
	self->priv->regular_bonus_left = _tmp0_ - 1;
	result = self->priv->regular_bonus_maxi - self->priv->regular_bonus_left;
	return result;
}

inline gboolean
boni_last_regular_bonus (Boni* self)
{
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	result = ((gint) self->priv->regular_bonus_left) == 0;
	return result;
}

inline gboolean
boni_too_many_missed (Boni* self)
{
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->missed > BONI_MAX_MISSED;
	return result;
}

static inline void
boni_increase_missed (Boni* self)
{
	guint8 _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->missed;
	self->priv->missed = _tmp0_ + 1;
}

static inline void
boni_reset_missed (Boni* self)
{
	g_return_if_fail (self != NULL);
	self->priv->missed = (guint8) 0;
}

Boni*
boni_construct (GType object_type)
{
	Boni * self = NULL;
	self = (Boni*) g_object_new (object_type, NULL);
	return self;
}

Boni*
boni_new (void)
{
	return boni_construct (TYPE_BONI);
}

static void
boni_class_init (BoniClass * klass,
                 gpointer klass_data)
{
	boni_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &Boni_private_offset);
	G_OBJECT_CLASS (klass)->finalize = boni_finalize;
	boni_signals[BONI_BONUS_REMOVED_SIGNAL] = g_signal_new ("bonus-removed", TYPE_BONI, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, TYPE_BONUS);
}

static void
boni_instance_init (Boni * self,
                    gpointer klass)
{
	GeeLinkedList* _tmp0_;
	self->priv = boni_get_instance_private (self);
	_tmp0_ = gee_linked_list_new (TYPE_BONUS, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	self->priv->bonuses = _tmp0_;
	self->priv->regular_bonus_left = (guint8) 0;
	self->priv->regular_bonus_maxi = (guint8) 0;
	self->priv->total_bonus_number = (guint8) 0;
	self->priv->missed = (guint8) 0;
}

static void
boni_finalize (GObject * obj)
{
	Boni * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_BONI, Boni);
	_g_object_unref0 (self->priv->bonuses);
	G_OBJECT_CLASS (boni_parent_class)->finalize (obj);
}

static GType
boni_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (BoniClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) boni_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Boni), 0, (GInstanceInitFunc) boni_instance_init, NULL };
	GType boni_type_id;
	boni_type_id = g_type_register_static (G_TYPE_OBJECT, "Boni", &g_define_type_info, 0);
	Boni_private_offset = g_type_add_instance_private (boni_type_id, sizeof (BoniPrivate));
	return boni_type_id;
}

GType
boni_get_type (void)
{
	static volatile gsize boni_type_id__volatile = 0;
	if (g_once_init_enter (&boni_type_id__volatile)) {
		GType boni_type_id;
		boni_type_id = boni_get_type_once ();
		g_once_init_leave (&boni_type_id__volatile, boni_type_id);
	}
	return boni_type_id__volatile;
}

