/* preferences-dialog.c generated by valac 0.48.13, the Vala compiler
 * generated from preferences-dialog.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*-
 * Gnome Nibbles: Gnome Worm Game
 * Copyright (C) 2015 Gabriel Ivascu <ivascu.gabriel59@gmail.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <gee.h>
#include <glib.h>
#include <glib/gi18n-lib.h>
#include <stdlib.h>
#include <string.h>
#include <gdk/gdk.h>

#define TYPE_PREFERENCES_DIALOG (preferences_dialog_get_type ())
#define PREFERENCES_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PREFERENCES_DIALOG, PreferencesDialog))
#define PREFERENCES_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PREFERENCES_DIALOG, PreferencesDialogClass))
#define IS_PREFERENCES_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PREFERENCES_DIALOG))
#define IS_PREFERENCES_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PREFERENCES_DIALOG))
#define PREFERENCES_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PREFERENCES_DIALOG, PreferencesDialogClass))

typedef struct _PreferencesDialog PreferencesDialog;
typedef struct _PreferencesDialogClass PreferencesDialogClass;
typedef struct _PreferencesDialogPrivate PreferencesDialogPrivate;
enum  {
	PREFERENCES_DIALOG_0_PROPERTY,
	PREFERENCES_DIALOG_N_WORMS_PROPERTY,
	PREFERENCES_DIALOG_NUM_PROPERTIES
};
static GParamSpec* preferences_dialog_properties[PREFERENCES_DIALOG_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define __vala_GtkTreePath_free0(var) ((var == NULL) ? NULL : (var = (_vala_GtkTreePath_free (var), NULL)))

struct _PreferencesDialog {
	GtkWindow parent_instance;
	PreferencesDialogPrivate * priv;
};

struct _PreferencesDialogClass {
	GtkWindowClass parent_class;
};

struct _PreferencesDialogPrivate {
	GSettings* settings;
	GeeArrayList* worm_settings;
	GtkStack* stack;
	GtkStack* headerbar_stack;
	GtkComboBoxText* worm_combobox;
	GtkListStore* list_store_1;
	GtkListStore* list_store_2;
	GtkListStore* list_store_3;
	GtkListStore* list_store_4;
	GtkTreeView* tree_view_1;
	GtkTreeView* tree_view_2;
	GtkTreeView* tree_view_3;
	GtkTreeView* tree_view_4;
	GtkComboBoxText* combo_box_1;
	GtkComboBoxText* combo_box_2;
	GtkComboBoxText* combo_box_3;
	GtkComboBoxText* combo_box_4;
	GeeArrayList* list_stores;
	GeeArrayList* tree_views;
	GeeArrayList* combo_boxes;
	GtkEventControllerKey* key_controller;
	gint _n_worms;
};

static gint PreferencesDialog_private_offset;
static gpointer preferences_dialog_parent_class = NULL;

GType preferences_dialog_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PreferencesDialog, g_object_unref)
PreferencesDialog* preferences_dialog_new (GtkApplicationWindow* window,
                                           GSettings* settings,
                                           GeeArrayList* worm_settings,
                                           gint worm_id,
                                           gint n_worms);
PreferencesDialog* preferences_dialog_construct (GType object_type,
                                                 GtkApplicationWindow* window,
                                                 GSettings* settings,
                                                 GeeArrayList* worm_settings,
                                                 gint worm_id,
                                                 gint n_worms);
static void preferences_dialog_accel_edited_cb (PreferencesDialog* self,
                                         GtkCellRendererAccel* cell,
                                         const gchar* path_string,
                                         guint keyval,
                                         GdkModifierType mask,
                                         guint hardware_keycode);
static void _preferences_dialog_accel_edited_cb_gtk_cell_renderer_accel_accel_edited (GtkCellRendererAccel* _sender,
                                                                               const gchar* path_string,
                                                                               guint accel_key,
                                                                               GdkModifierType accel_mods,
                                                                               guint hardware_keycode,
                                                                               gpointer self);
static void preferences_dialog_accel_cleared_cb (PreferencesDialog* self,
                                          GtkCellRendererAccel* cell,
                                          const gchar* path_string);
static void _preferences_dialog_accel_cleared_cb_gtk_cell_renderer_accel_accel_cleared (GtkCellRendererAccel* _sender,
                                                                                 const gchar* path_string,
                                                                                 gpointer self);
#define NIBBLES_VIEW_NUM_COLORS 6
gchar* nibbles_view_colorval_name_translated (gint colorval);
static void preferences_dialog_combo_box_changed_cb (PreferencesDialog* self,
                                              GtkComboBox* combo_box);
static void _preferences_dialog_combo_box_changed_cb_gtk_combo_box_changed (GtkComboBox* _sender,
                                                                     gpointer self);
static inline gboolean preferences_dialog_on_key_pressed (PreferencesDialog* self,
                                            GtkEventControllerKey* _key_controller,
                                            guint keyval,
                                            guint keycode,
                                            GdkModifierType state);
static inline void preferences_dialog_on_worm_change (PreferencesDialog* self,
                                        GtkComboBox* _worm_combobox);
static void _preferences_dialog_on_worm_change_gtk_combo_box_changed (GtkComboBox* _sender,
                                                               gpointer self);
static void _vala_GtkTreePath_free (GtkTreePath* self);
static gint preferences_dialog_get_n_worms (PreferencesDialog* self);
#define NIBBLES_GAME_MAX_WORMS 6
static void preferences_dialog_set_n_worms (PreferencesDialog* self,
                                     gint value);
static GObject * preferences_dialog_constructor (GType type,
                                          guint n_construct_properties,
                                          GObjectConstructParam * construct_properties);
static gboolean _preferences_dialog_on_key_pressed_gtk_event_controller_key_key_pressed (GtkEventControllerKey* _sender,
                                                                                  guint keyval,
                                                                                  guint keycode,
                                                                                  GdkModifierType state,
                                                                                  gpointer self);
static void preferences_dialog_finalize (GObject * obj);
static GType preferences_dialog_get_type_once (void);
static void _vala_preferences_dialog_get_property (GObject * object,
                                            guint property_id,
                                            GValue * value,
                                            GParamSpec * pspec);
static void _vala_preferences_dialog_set_property (GObject * object,
                                            guint property_id,
                                            const GValue * value,
                                            GParamSpec * pspec);

static inline gpointer
preferences_dialog_get_instance_private (PreferencesDialog* self)
{
	return G_STRUCT_MEMBER_P (self, PreferencesDialog_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
_preferences_dialog_accel_edited_cb_gtk_cell_renderer_accel_accel_edited (GtkCellRendererAccel* _sender,
                                                                          const gchar* path_string,
                                                                          guint accel_key,
                                                                          GdkModifierType accel_mods,
                                                                          guint hardware_keycode,
                                                                          gpointer self)
{
	preferences_dialog_accel_edited_cb ((PreferencesDialog*) self, _sender, path_string, accel_key, accel_mods, hardware_keycode);
}

static void
_preferences_dialog_accel_cleared_cb_gtk_cell_renderer_accel_accel_cleared (GtkCellRendererAccel* _sender,
                                                                            const gchar* path_string,
                                                                            gpointer self)
{
	preferences_dialog_accel_cleared_cb ((PreferencesDialog*) self, _sender, path_string);
}

static void
_preferences_dialog_combo_box_changed_cb_gtk_combo_box_changed (GtkComboBox* _sender,
                                                                gpointer self)
{
	preferences_dialog_combo_box_changed_cb ((PreferencesDialog*) self, _sender);
}

PreferencesDialog*
preferences_dialog_construct (GType object_type,
                              GtkApplicationWindow* window,
                              GSettings* settings,
                              GeeArrayList* worm_settings,
                              gint worm_id,
                              gint n_worms)
{
	PreferencesDialog * self = NULL;
	GSettings* _tmp0_;
	GeeArrayList* _tmp1_;
	GtkComboBoxText* _tmp75_;
	g_return_val_if_fail (window != NULL, NULL);
	g_return_val_if_fail (settings != NULL, NULL);
	g_return_val_if_fail (worm_settings != NULL, NULL);
	self = (PreferencesDialog*) g_object_new (object_type, "transient-for", window, "n-worms", n_worms, NULL);
	_tmp0_ = _g_object_ref0 (settings);
	_g_object_unref0 (self->priv->settings);
	self->priv->settings = _tmp0_;
	_tmp1_ = _g_object_ref0 (worm_settings);
	_g_object_unref0 (self->priv->worm_settings);
	self->priv->worm_settings = _tmp1_;
	if (n_worms == 1) {
		GtkStack* _tmp2_;
		_tmp2_ = self->priv->headerbar_stack;
		gtk_stack_set_visible_child_name (_tmp2_, "preferences-label");
	} else {
		if (n_worms != 4) {
			{
				gint i = 0;
				i = 3;
				{
					gboolean _tmp3_ = FALSE;
					_tmp3_ = TRUE;
					while (TRUE) {
						GtkComboBoxText* _tmp5_;
						if (!_tmp3_) {
							gint _tmp4_;
							_tmp4_ = i;
							i = _tmp4_ - 1;
						}
						_tmp3_ = FALSE;
						if (!(i > (n_worms - 1))) {
							break;
						}
						_tmp5_ = self->priv->worm_combobox;
						gtk_combo_box_text_remove (_tmp5_, i);
					}
				}
			}
		}
	}
	{
		GeeArrayList* _list_store_list = NULL;
		GeeArrayList* _tmp6_;
		GeeArrayList* _tmp7_;
		gint _list_store_size = 0;
		GeeArrayList* _tmp8_;
		gint _tmp9_;
		gint _tmp10_;
		gint _list_store_index = 0;
		_tmp6_ = self->priv->list_stores;
		_tmp7_ = _g_object_ref0 (_tmp6_);
		_list_store_list = _tmp7_;
		_tmp8_ = _list_store_list;
		_tmp9_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp8_);
		_tmp10_ = _tmp9_;
		_list_store_size = _tmp10_;
		_list_store_index = -1;
		while (TRUE) {
			gint _tmp11_;
			gint _tmp12_;
			GtkListStore* list_store = NULL;
			GeeArrayList* _tmp13_;
			gpointer _tmp14_;
			gint id = 0;
			GeeArrayList* _tmp15_;
			GtkListStore* _tmp16_;
			GtkTreeView* tree_view = NULL;
			GeeArrayList* _tmp17_;
			gpointer _tmp18_;
			GtkTreeIter iter = {0};
			GtkListStore* _tmp19_;
			GtkTreeIter _tmp20_ = {0};
			gint keyval = 0;
			gpointer _tmp21_;
			GSettings* _tmp22_;
			gint _tmp23_;
			GtkListStore* _tmp24_;
			GtkTreeIter _tmp25_;
			GtkListStore* _tmp26_;
			GtkTreeIter _tmp27_ = {0};
			gpointer _tmp28_;
			GSettings* _tmp29_;
			GtkListStore* _tmp30_;
			GtkTreeIter _tmp31_;
			GtkListStore* _tmp32_;
			GtkTreeIter _tmp33_ = {0};
			gpointer _tmp34_;
			GSettings* _tmp35_;
			GtkListStore* _tmp36_;
			GtkTreeIter _tmp37_;
			GtkListStore* _tmp38_;
			GtkTreeIter _tmp39_ = {0};
			gpointer _tmp40_;
			GSettings* _tmp41_;
			GtkListStore* _tmp42_;
			GtkTreeIter _tmp43_;
			GtkCellRendererText* label_renderer = NULL;
			GtkCellRendererText* _tmp44_;
			GtkTreeView* _tmp45_;
			GtkCellRendererText* _tmp46_;
			GtkCellRendererAccel* key_renderer = NULL;
			GtkCellRendererAccel* _tmp47_;
			GtkCellRendererAccel* _tmp48_;
			GtkCellRendererAccel* _tmp49_;
			GtkCellRendererAccel* _tmp50_;
			GtkCellRendererAccel* _tmp51_;
			GtkTreeView* _tmp52_;
			GtkCellRendererAccel* _tmp53_;
			_list_store_index = _list_store_index + 1;
			_tmp11_ = _list_store_index;
			_tmp12_ = _list_store_size;
			if (!(_tmp11_ < _tmp12_)) {
				break;
			}
			_tmp13_ = _list_store_list;
			_tmp14_ = gee_abstract_list_get ((GeeAbstractList*) _tmp13_, _list_store_index);
			list_store = (GtkListStore*) _tmp14_;
			_tmp15_ = self->priv->list_stores;
			_tmp16_ = list_store;
			id = gee_abstract_list_index_of ((GeeAbstractList*) _tmp15_, _tmp16_);
			_tmp17_ = self->priv->tree_views;
			_tmp18_ = gee_abstract_list_get ((GeeAbstractList*) _tmp17_, id);
			tree_view = (GtkTreeView*) _tmp18_;
			_tmp19_ = list_store;
			gtk_list_store_append (_tmp19_, &_tmp20_);
			iter = _tmp20_;
			_tmp21_ = gee_abstract_list_get ((GeeAbstractList*) worm_settings, id);
			_tmp22_ = (GSettings*) _tmp21_;
			_tmp23_ = g_settings_get_int (_tmp22_, "key-up");
			_g_object_unref0 (_tmp22_);
			keyval = _tmp23_;
			_tmp24_ = list_store;
			_tmp25_ = iter;
			gtk_list_store_set (_tmp24_, &_tmp25_, 0, "key-up", 1, _ ("Move up"), 2, keyval, -1);
			_tmp26_ = list_store;
			gtk_list_store_append (_tmp26_, &_tmp27_);
			iter = _tmp27_;
			_tmp28_ = gee_abstract_list_get ((GeeAbstractList*) worm_settings, id);
			_tmp29_ = (GSettings*) _tmp28_;
			keyval = g_settings_get_int (_tmp29_, "key-down");
			_g_object_unref0 (_tmp29_);
			_tmp30_ = list_store;
			_tmp31_ = iter;
			gtk_list_store_set (_tmp30_, &_tmp31_, 0, "key-down", 1, _ ("Move down"), 2, keyval, -1);
			_tmp32_ = list_store;
			gtk_list_store_append (_tmp32_, &_tmp33_);
			iter = _tmp33_;
			_tmp34_ = gee_abstract_list_get ((GeeAbstractList*) worm_settings, id);
			_tmp35_ = (GSettings*) _tmp34_;
			keyval = g_settings_get_int (_tmp35_, "key-left");
			_g_object_unref0 (_tmp35_);
			_tmp36_ = list_store;
			_tmp37_ = iter;
			gtk_list_store_set (_tmp36_, &_tmp37_, 0, "key-left", 1, _ ("Move left"), 2, keyval, -1);
			_tmp38_ = list_store;
			gtk_list_store_append (_tmp38_, &_tmp39_);
			iter = _tmp39_;
			_tmp40_ = gee_abstract_list_get ((GeeAbstractList*) worm_settings, id);
			_tmp41_ = (GSettings*) _tmp40_;
			keyval = g_settings_get_int (_tmp41_, "key-right");
			_g_object_unref0 (_tmp41_);
			_tmp42_ = list_store;
			_tmp43_ = iter;
			gtk_list_store_set (_tmp42_, &_tmp43_, 0, "key-right", 1, _ ("Move right"), 2, keyval, -1);
			_tmp44_ = (GtkCellRendererText*) gtk_cell_renderer_text_new ();
			g_object_ref_sink (_tmp44_);
			label_renderer = _tmp44_;
			_tmp45_ = tree_view;
			_tmp46_ = label_renderer;
			gtk_tree_view_insert_column_with_attributes (_tmp45_, -1, _ ("Action"), (GtkCellRenderer*) _tmp46_, "text", 1, NULL);
			_tmp47_ = (GtkCellRendererAccel*) gtk_cell_renderer_accel_new ();
			g_object_ref_sink (_tmp47_);
			key_renderer = _tmp47_;
			_tmp48_ = key_renderer;
			g_object_set ((GtkCellRendererText*) _tmp48_, "editable", TRUE, NULL);
			_tmp49_ = key_renderer;
			g_object_set (_tmp49_, "accel-mode", GTK_CELL_RENDERER_ACCEL_MODE_OTHER, NULL);
			_tmp50_ = key_renderer;
			g_signal_connect_object (_tmp50_, "accel-edited", (GCallback) _preferences_dialog_accel_edited_cb_gtk_cell_renderer_accel_accel_edited, self, 0);
			_tmp51_ = key_renderer;
			g_signal_connect_object (_tmp51_, "accel-cleared", (GCallback) _preferences_dialog_accel_cleared_cb_gtk_cell_renderer_accel_accel_cleared, self, 0);
			_tmp52_ = tree_view;
			_tmp53_ = key_renderer;
			gtk_tree_view_insert_column_with_attributes (_tmp52_, -1, _ ("Key"), (GtkCellRenderer*) _tmp53_, "accel-key", 2, NULL);
			_g_object_unref0 (key_renderer);
			_g_object_unref0 (label_renderer);
			_g_object_unref0 (tree_view);
			_g_object_unref0 (list_store);
		}
		_g_object_unref0 (_list_store_list);
	}
	{
		GeeArrayList* _combo_box_list = NULL;
		GeeArrayList* _tmp54_;
		GeeArrayList* _tmp55_;
		gint _combo_box_size = 0;
		GeeArrayList* _tmp56_;
		gint _tmp57_;
		gint _tmp58_;
		gint _combo_box_index = 0;
		_tmp54_ = self->priv->combo_boxes;
		_tmp55_ = _g_object_ref0 (_tmp54_);
		_combo_box_list = _tmp55_;
		_tmp56_ = _combo_box_list;
		_tmp57_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp56_);
		_tmp58_ = _tmp57_;
		_combo_box_size = _tmp58_;
		_combo_box_index = -1;
		while (TRUE) {
			gint _tmp59_;
			gint _tmp60_;
			GtkComboBoxText* combo_box = NULL;
			GeeArrayList* _tmp61_;
			gpointer _tmp62_;
			gint id = 0;
			GeeArrayList* _tmp68_;
			GtkComboBoxText* _tmp69_;
			gint color = 0;
			gpointer _tmp70_;
			GSettings* _tmp71_;
			gint _tmp72_;
			GtkComboBoxText* _tmp73_;
			GtkComboBoxText* _tmp74_;
			_combo_box_index = _combo_box_index + 1;
			_tmp59_ = _combo_box_index;
			_tmp60_ = _combo_box_size;
			if (!(_tmp59_ < _tmp60_)) {
				break;
			}
			_tmp61_ = _combo_box_list;
			_tmp62_ = gee_abstract_list_get ((GeeAbstractList*) _tmp61_, _combo_box_index);
			combo_box = (GtkComboBoxText*) _tmp62_;
			{
				gint i = 0;
				i = 0;
				{
					gboolean _tmp63_ = FALSE;
					_tmp63_ = TRUE;
					while (TRUE) {
						GtkComboBoxText* _tmp65_;
						gchar* _tmp66_;
						gchar* _tmp67_;
						if (!_tmp63_) {
							gint _tmp64_;
							_tmp64_ = i;
							i = _tmp64_ + 1;
						}
						_tmp63_ = FALSE;
						if (!(i < NIBBLES_VIEW_NUM_COLORS)) {
							break;
						}
						_tmp65_ = combo_box;
						_tmp66_ = nibbles_view_colorval_name_translated (i);
						_tmp67_ = _tmp66_;
						gtk_combo_box_text_append_text (_tmp65_, _tmp67_);
						_g_free0 (_tmp67_);
					}
				}
			}
			_tmp68_ = self->priv->combo_boxes;
			_tmp69_ = combo_box;
			id = gee_abstract_list_index_of ((GeeAbstractList*) _tmp68_, _tmp69_);
			_tmp70_ = gee_abstract_list_get ((GeeAbstractList*) worm_settings, id);
			_tmp71_ = (GSettings*) _tmp70_;
			_tmp72_ = g_settings_get_enum (_tmp71_, "color");
			_g_object_unref0 (_tmp71_);
			color = _tmp72_;
			_tmp73_ = combo_box;
			gtk_combo_box_set_active ((GtkComboBox*) _tmp73_, color);
			_tmp74_ = combo_box;
			g_signal_connect_object ((GtkComboBox*) _tmp74_, "changed", (GCallback) _preferences_dialog_combo_box_changed_cb_gtk_combo_box_changed, self, 0);
			_g_object_unref0 (combo_box);
		}
		_g_object_unref0 (_combo_box_list);
	}
	_tmp75_ = self->priv->worm_combobox;
	gtk_combo_box_set_active ((GtkComboBox*) _tmp75_, worm_id - 1);
	return self;
}

PreferencesDialog*
preferences_dialog_new (GtkApplicationWindow* window,
                        GSettings* settings,
                        GeeArrayList* worm_settings,
                        gint worm_id,
                        gint n_worms)
{
	return preferences_dialog_construct (TYPE_PREFERENCES_DIALOG, window, settings, worm_settings, worm_id, n_worms);
}

static inline gboolean
preferences_dialog_on_key_pressed (PreferencesDialog* self,
                                   GtkEventControllerKey* _key_controller,
                                   guint keyval,
                                   guint keycode,
                                   GdkModifierType state)
{
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_;
	gchar* name = NULL;
	gchar* _tmp2_;
	const gchar* _tmp3_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (_key_controller != NULL, FALSE);
	_tmp1_ = gdk_keyval_name (keyval);
	_tmp0_ = _tmp1_;
	if (_tmp0_ == NULL) {
		_tmp0_ = "";
	}
	_tmp2_ = g_strdup ((const gchar*) _tmp0_);
	name = _tmp2_;
	_tmp3_ = name;
	if (g_strcmp0 (_tmp3_, "Escape") == 0) {
		gtk_widget_destroy ((GtkWidget*) self);
	}
	result = FALSE;
	_g_free0 (name);
	return result;
}

static inline void
preferences_dialog_on_worm_change (PreferencesDialog* self,
                                   GtkComboBox* _worm_combobox)
{
	GtkStack* _tmp0_;
	const gchar* _tmp1_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (_worm_combobox != NULL);
	_tmp0_ = self->priv->stack;
	_tmp1_ = gtk_combo_box_get_active_id ((GtkComboBox*) G_TYPE_CHECK_INSTANCE_CAST (_worm_combobox, gtk_combo_box_text_get_type (), GtkComboBoxText));
	gtk_stack_set_visible_child_name (_tmp0_, _tmp1_);
}

static void
_preferences_dialog_on_worm_change_gtk_combo_box_changed (GtkComboBox* _sender,
                                                          gpointer self)
{
	preferences_dialog_on_worm_change ((PreferencesDialog*) self, _sender);
}

static void
_vala_GtkTreePath_free (GtkTreePath* self)
{
	g_boxed_free (gtk_tree_path_get_type (), self);
}

static void
preferences_dialog_accel_edited_cb (PreferencesDialog* self,
                                    GtkCellRendererAccel* cell,
                                    const gchar* path_string,
                                    guint keyval,
                                    GdkModifierType mask,
                                    guint hardware_keycode)
{
	GtkTreePath* path = NULL;
	GtkTreePath* _tmp0_;
	GtkTreePath* _tmp1_;
	gint id = 0;
	GtkComboBoxText* _tmp2_;
	GtkListStore* list_store = NULL;
	GeeArrayList* _tmp3_;
	gpointer _tmp4_;
	GtkTreeIter it = {0};
	GtkListStore* _tmp5_;
	GtkTreePath* _tmp6_;
	GtkTreeIter _tmp7_ = {0};
	gboolean _tmp8_;
	gchar* key = NULL;
	GtkListStore* _tmp9_;
	GtkTreeIter _tmp10_;
	gchar* _tmp11_ = NULL;
	const gchar* _tmp12_;
	GeeArrayList* _tmp13_;
	gpointer _tmp14_;
	GSettings* _tmp15_;
	const gchar* _tmp16_;
	gboolean _tmp17_;
	gboolean valid = FALSE;
	g_return_if_fail (self != NULL);
	g_return_if_fail (cell != NULL);
	g_return_if_fail (path_string != NULL);
	_tmp0_ = gtk_tree_path_new_from_string (path_string);
	path = _tmp0_;
	_tmp1_ = path;
	if (_tmp1_ == NULL) {
		__vala_GtkTreePath_free0 (path);
		return;
	}
	_tmp2_ = self->priv->worm_combobox;
	id = gtk_combo_box_get_active ((GtkComboBox*) _tmp2_);
	_tmp3_ = self->priv->list_stores;
	_tmp4_ = gee_abstract_list_get ((GeeAbstractList*) _tmp3_, id);
	list_store = (GtkListStore*) _tmp4_;
	_tmp5_ = list_store;
	_tmp6_ = path;
	_tmp8_ = gtk_tree_model_get_iter ((GtkTreeModel*) _tmp5_, &_tmp7_, _tmp6_);
	it = _tmp7_;
	if (!_tmp8_) {
		_g_object_unref0 (list_store);
		__vala_GtkTreePath_free0 (path);
		return;
	}
	key = NULL;
	_tmp9_ = list_store;
	_tmp10_ = it;
	gtk_tree_model_get ((GtkTreeModel*) _tmp9_, &_tmp10_, 0, &_tmp11_, -1);
	_g_free0 (key);
	key = _tmp11_;
	_tmp12_ = key;
	if (_tmp12_ == NULL) {
		_g_free0 (key);
		_g_object_unref0 (list_store);
		__vala_GtkTreePath_free0 (path);
		return;
	}
	_tmp13_ = self->priv->worm_settings;
	_tmp14_ = gee_abstract_list_get ((GeeAbstractList*) _tmp13_, id);
	_tmp15_ = (GSettings*) _tmp14_;
	_tmp16_ = key;
	_tmp17_ = keyval == ((guint) g_settings_get_int (_tmp15_, _tmp16_));
	_g_object_unref0 (_tmp15_);
	if (_tmp17_) {
		_g_free0 (key);
		_g_object_unref0 (list_store);
		__vala_GtkTreePath_free0 (path);
		return;
	}
	valid = TRUE;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp18_ = FALSE;
			_tmp18_ = TRUE;
			while (TRUE) {
				gint _tmp20_;
				gboolean _tmp21_ = FALSE;
				gboolean _tmp22_ = FALSE;
				gboolean _tmp23_ = FALSE;
				GeeArrayList* _tmp24_;
				gpointer _tmp25_;
				GSettings* _tmp26_;
				gboolean _tmp27_;
				if (!_tmp18_) {
					gint _tmp19_;
					_tmp19_ = i;
					i = _tmp19_ + 1;
				}
				_tmp18_ = FALSE;
				_tmp20_ = self->priv->_n_worms;
				if (!(i < _tmp20_)) {
					break;
				}
				_tmp24_ = self->priv->worm_settings;
				_tmp25_ = gee_abstract_list_get ((GeeAbstractList*) _tmp24_, i);
				_tmp26_ = (GSettings*) _tmp25_;
				_tmp27_ = keyval == ((guint) g_settings_get_int (_tmp26_, "key-up"));
				_g_object_unref0 (_tmp26_);
				if (_tmp27_) {
					_tmp23_ = TRUE;
				} else {
					GeeArrayList* _tmp28_;
					gpointer _tmp29_;
					GSettings* _tmp30_;
					_tmp28_ = self->priv->worm_settings;
					_tmp29_ = gee_abstract_list_get ((GeeAbstractList*) _tmp28_, i);
					_tmp30_ = (GSettings*) _tmp29_;
					_tmp23_ = keyval == ((guint) g_settings_get_int (_tmp30_, "key-down"));
					_g_object_unref0 (_tmp30_);
				}
				if (_tmp23_) {
					_tmp22_ = TRUE;
				} else {
					GeeArrayList* _tmp31_;
					gpointer _tmp32_;
					GSettings* _tmp33_;
					_tmp31_ = self->priv->worm_settings;
					_tmp32_ = gee_abstract_list_get ((GeeAbstractList*) _tmp31_, i);
					_tmp33_ = (GSettings*) _tmp32_;
					_tmp22_ = keyval == ((guint) g_settings_get_int (_tmp33_, "key-left"));
					_g_object_unref0 (_tmp33_);
				}
				if (_tmp22_) {
					_tmp21_ = TRUE;
				} else {
					GeeArrayList* _tmp34_;
					gpointer _tmp35_;
					GSettings* _tmp36_;
					_tmp34_ = self->priv->worm_settings;
					_tmp35_ = gee_abstract_list_get ((GeeAbstractList*) _tmp34_, i);
					_tmp36_ = (GSettings*) _tmp35_;
					_tmp21_ = keyval == ((guint) g_settings_get_int (_tmp36_, "key-right"));
					_g_object_unref0 (_tmp36_);
				}
				if (_tmp21_) {
					GtkMessageDialog* dialog = NULL;
					GtkMessageDialog* _tmp37_;
					GtkMessageDialog* _tmp38_;
					gint response = 0;
					GtkMessageDialog* _tmp39_;
					GtkMessageDialog* _tmp40_;
					_tmp37_ = (GtkMessageDialog*) gtk_message_dialog_new ((GtkWindow*) self, GTK_DIALOG_DESTROY_WITH_PARENT | GTK_DIALOG_MODAL, GTK_MESSAGE_WARNING, GTK_BUTTONS_CANCEL, "%s", _ ("The key you selected is already assigned!"));
					g_object_ref_sink (_tmp37_);
					dialog = _tmp37_;
					_tmp38_ = dialog;
					gtk_dialog_add_button ((GtkDialog*) _tmp38_, _ ("_Set anyway"), 42);
					_tmp39_ = dialog;
					response = gtk_dialog_run ((GtkDialog*) _tmp39_);
					_tmp40_ = dialog;
					gtk_widget_destroy ((GtkWidget*) _tmp40_);
					if (response != 42) {
						valid = FALSE;
					}
					_g_object_unref0 (dialog);
					break;
				}
			}
		}
	}
	if (valid) {
		GtkListStore* _tmp41_;
		GtkTreeIter _tmp42_;
		GeeArrayList* _tmp43_;
		gpointer _tmp44_;
		GSettings* _tmp45_;
		const gchar* _tmp46_;
		_tmp41_ = list_store;
		_tmp42_ = it;
		gtk_list_store_set (_tmp41_, &_tmp42_, 2, keyval, -1);
		_tmp43_ = self->priv->worm_settings;
		_tmp44_ = gee_abstract_list_get ((GeeAbstractList*) _tmp43_, id);
		_tmp45_ = (GSettings*) _tmp44_;
		_tmp46_ = key;
		g_settings_set_int (_tmp45_, _tmp46_, (gint) keyval);
		_g_object_unref0 (_tmp45_);
	}
	_g_free0 (key);
	_g_object_unref0 (list_store);
	__vala_GtkTreePath_free0 (path);
}

static void
preferences_dialog_accel_cleared_cb (PreferencesDialog* self,
                                     GtkCellRendererAccel* cell,
                                     const gchar* path_string)
{
	GtkTreePath* path = NULL;
	GtkTreePath* _tmp0_;
	GtkTreePath* _tmp1_;
	gint id = 0;
	GtkComboBoxText* _tmp2_;
	GtkListStore* list_store = NULL;
	GeeArrayList* _tmp3_;
	gpointer _tmp4_;
	GtkTreeIter it = {0};
	GtkListStore* _tmp5_;
	GtkTreePath* _tmp6_;
	GtkTreeIter _tmp7_ = {0};
	gboolean _tmp8_;
	gchar* key = NULL;
	GtkListStore* _tmp9_;
	GtkTreeIter _tmp10_;
	gchar* _tmp11_ = NULL;
	const gchar* _tmp12_;
	GtkListStore* _tmp13_;
	GtkTreeIter _tmp14_;
	GeeArrayList* _tmp15_;
	gpointer _tmp16_;
	GSettings* _tmp17_;
	const gchar* _tmp18_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (cell != NULL);
	g_return_if_fail (path_string != NULL);
	_tmp0_ = gtk_tree_path_new_from_string (path_string);
	path = _tmp0_;
	_tmp1_ = path;
	if (_tmp1_ == NULL) {
		__vala_GtkTreePath_free0 (path);
		return;
	}
	_tmp2_ = self->priv->worm_combobox;
	id = gtk_combo_box_get_active ((GtkComboBox*) _tmp2_);
	_tmp3_ = self->priv->list_stores;
	_tmp4_ = gee_abstract_list_get ((GeeAbstractList*) _tmp3_, id);
	list_store = (GtkListStore*) _tmp4_;
	_tmp5_ = list_store;
	_tmp6_ = path;
	_tmp8_ = gtk_tree_model_get_iter ((GtkTreeModel*) _tmp5_, &_tmp7_, _tmp6_);
	it = _tmp7_;
	if (!_tmp8_) {
		_g_object_unref0 (list_store);
		__vala_GtkTreePath_free0 (path);
		return;
	}
	key = NULL;
	_tmp9_ = list_store;
	_tmp10_ = it;
	gtk_tree_model_get ((GtkTreeModel*) _tmp9_, &_tmp10_, 0, &_tmp11_, -1);
	_g_free0 (key);
	key = _tmp11_;
	_tmp12_ = key;
	if (_tmp12_ == NULL) {
		_g_free0 (key);
		_g_object_unref0 (list_store);
		__vala_GtkTreePath_free0 (path);
		return;
	}
	_tmp13_ = list_store;
	_tmp14_ = it;
	gtk_list_store_set (_tmp13_, &_tmp14_, 2, 0, -1);
	_tmp15_ = self->priv->worm_settings;
	_tmp16_ = gee_abstract_list_get ((GeeAbstractList*) _tmp15_, id);
	_tmp17_ = (GSettings*) _tmp16_;
	_tmp18_ = key;
	g_settings_set_int (_tmp17_, _tmp18_, 0);
	_g_object_unref0 (_tmp17_);
	_g_free0 (key);
	_g_object_unref0 (list_store);
	__vala_GtkTreePath_free0 (path);
}

static void
preferences_dialog_combo_box_changed_cb (PreferencesDialog* self,
                                         GtkComboBox* combo_box)
{
	gint id = 0;
	GeeArrayList* _tmp0_;
	gint color_new = 0;
	gint color_old = 0;
	GeeArrayList* _tmp1_;
	gpointer _tmp2_;
	GSettings* _tmp3_;
	gint _tmp4_;
	GeeArrayList* _tmp27_;
	gpointer _tmp28_;
	GSettings* _tmp29_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (combo_box != NULL);
	_tmp0_ = self->priv->combo_boxes;
	id = gee_abstract_list_index_of ((GeeAbstractList*) _tmp0_, G_TYPE_CHECK_INSTANCE_CAST (combo_box, gtk_combo_box_text_get_type (), GtkComboBoxText));
	color_new = gtk_combo_box_get_active (combo_box);
	_tmp1_ = self->priv->worm_settings;
	_tmp2_ = gee_abstract_list_get ((GeeAbstractList*) _tmp1_, id);
	_tmp3_ = (GSettings*) _tmp2_;
	_tmp4_ = g_settings_get_enum (_tmp3_, "color");
	_g_object_unref0 (_tmp3_);
	color_old = _tmp4_;
	if (color_new == color_old) {
		return;
	}
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp5_ = FALSE;
			_tmp5_ = TRUE;
			while (TRUE) {
				gboolean _tmp7_ = FALSE;
				if (!_tmp5_) {
					gint _tmp6_;
					_tmp6_ = i;
					i = _tmp6_ + 1;
				}
				_tmp5_ = FALSE;
				if (!(i < NIBBLES_GAME_MAX_WORMS)) {
					break;
				}
				if (i != id) {
					GeeArrayList* _tmp8_;
					gpointer _tmp9_;
					GSettings* _tmp10_;
					_tmp8_ = self->priv->worm_settings;
					_tmp9_ = gee_abstract_list_get ((GeeAbstractList*) _tmp8_, i);
					_tmp10_ = (GSettings*) _tmp9_;
					_tmp7_ = g_settings_get_enum (_tmp10_, "color") == color_new;
					_g_object_unref0 (_tmp10_);
				} else {
					_tmp7_ = FALSE;
				}
				if (_tmp7_) {
					GeeArrayList* _tmp11_;
					gpointer _tmp12_;
					GSettings* _tmp13_;
					gint _tmp14_;
					_tmp11_ = self->priv->worm_settings;
					_tmp12_ = gee_abstract_list_get ((GeeAbstractList*) _tmp11_, i);
					_tmp13_ = (GSettings*) _tmp12_;
					g_settings_set_enum (_tmp13_, "color", color_old);
					_g_object_unref0 (_tmp13_);
					_tmp14_ = self->priv->_n_worms;
					if (i < _tmp14_) {
						{
							GeeArrayList* _cbox_list = NULL;
							GeeArrayList* _tmp15_;
							GeeArrayList* _tmp16_;
							gint _cbox_size = 0;
							GeeArrayList* _tmp17_;
							gint _tmp18_;
							gint _tmp19_;
							gint _cbox_index = 0;
							_tmp15_ = self->priv->combo_boxes;
							_tmp16_ = _g_object_ref0 (_tmp15_);
							_cbox_list = _tmp16_;
							_tmp17_ = _cbox_list;
							_tmp18_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp17_);
							_tmp19_ = _tmp18_;
							_cbox_size = _tmp19_;
							_cbox_index = -1;
							while (TRUE) {
								gint _tmp20_;
								gint _tmp21_;
								GtkComboBoxText* cbox = NULL;
								GeeArrayList* _tmp22_;
								gpointer _tmp23_;
								gint index = 0;
								GeeArrayList* _tmp24_;
								GtkComboBoxText* _tmp25_;
								_cbox_index = _cbox_index + 1;
								_tmp20_ = _cbox_index;
								_tmp21_ = _cbox_size;
								if (!(_tmp20_ < _tmp21_)) {
									break;
								}
								_tmp22_ = _cbox_list;
								_tmp23_ = gee_abstract_list_get ((GeeAbstractList*) _tmp22_, _cbox_index);
								cbox = (GtkComboBoxText*) _tmp23_;
								_tmp24_ = self->priv->combo_boxes;
								_tmp25_ = cbox;
								index = gee_abstract_list_index_of ((GeeAbstractList*) _tmp24_, _tmp25_);
								if (index == i) {
									GtkComboBoxText* _tmp26_;
									_tmp26_ = cbox;
									gtk_combo_box_set_active ((GtkComboBox*) _tmp26_, color_old);
									_g_object_unref0 (cbox);
									break;
								}
								_g_object_unref0 (cbox);
							}
							_g_object_unref0 (_cbox_list);
						}
					}
					break;
				}
			}
		}
	}
	_tmp27_ = self->priv->worm_settings;
	_tmp28_ = gee_abstract_list_get ((GeeAbstractList*) _tmp27_, id);
	_tmp29_ = (GSettings*) _tmp28_;
	g_settings_set_enum (_tmp29_, "color", color_new);
	_g_object_unref0 (_tmp29_);
}

static gint
preferences_dialog_get_n_worms (PreferencesDialog* self)
{
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_n_worms;
	return result;
}

static void
preferences_dialog_set_n_worms (PreferencesDialog* self,
                                gint value)
{
	gint old_value;
	g_return_if_fail (self != NULL);
	old_value = preferences_dialog_get_n_worms (self);
	if (old_value != value) {
		self->priv->_n_worms = value;
		g_object_notify_by_pspec ((GObject *) self, preferences_dialog_properties[PREFERENCES_DIALOG_N_WORMS_PROPERTY]);
	}
}

static gboolean
_preferences_dialog_on_key_pressed_gtk_event_controller_key_key_pressed (GtkEventControllerKey* _sender,
                                                                         guint keyval,
                                                                         guint keycode,
                                                                         GdkModifierType state,
                                                                         gpointer self)
{
	gboolean result;
	result = preferences_dialog_on_key_pressed ((PreferencesDialog*) self, _sender, keyval, keycode, state);
	return result;
}

static GObject *
preferences_dialog_constructor (GType type,
                                guint n_construct_properties,
                                GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	PreferencesDialog * self;
	GtkEventControllerKey* _tmp0_;
	GtkEventControllerKey* _tmp1_;
	GeeArrayList* _tmp2_;
	GeeArrayList* _tmp3_;
	GtkTreeView* _tmp4_;
	GeeArrayList* _tmp5_;
	GtkTreeView* _tmp6_;
	GeeArrayList* _tmp7_;
	GtkTreeView* _tmp8_;
	GeeArrayList* _tmp9_;
	GtkTreeView* _tmp10_;
	GeeArrayList* _tmp11_;
	GeeArrayList* _tmp12_;
	GtkListStore* _tmp13_;
	GeeArrayList* _tmp14_;
	GtkListStore* _tmp15_;
	GeeArrayList* _tmp16_;
	GtkListStore* _tmp17_;
	GeeArrayList* _tmp18_;
	GtkListStore* _tmp19_;
	GeeArrayList* _tmp20_;
	GeeArrayList* _tmp21_;
	GtkComboBoxText* _tmp22_;
	GeeArrayList* _tmp23_;
	GtkComboBoxText* _tmp24_;
	GeeArrayList* _tmp25_;
	GtkComboBoxText* _tmp26_;
	GeeArrayList* _tmp27_;
	GtkComboBoxText* _tmp28_;
	parent_class = G_OBJECT_CLASS (preferences_dialog_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PREFERENCES_DIALOG, PreferencesDialog);
	_tmp0_ = (GtkEventControllerKey*) gtk_event_controller_key_new ((GtkWidget*) self);
	_g_object_unref0 (self->priv->key_controller);
	self->priv->key_controller = _tmp0_;
	_tmp1_ = self->priv->key_controller;
	g_signal_connect_object (_tmp1_, "key-pressed", (GCallback) _preferences_dialog_on_key_pressed_gtk_event_controller_key_key_pressed, self, 0);
	_tmp2_ = gee_array_list_new (gtk_tree_view_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	_g_object_unref0 (self->priv->tree_views);
	self->priv->tree_views = _tmp2_;
	_tmp3_ = self->priv->tree_views;
	_tmp4_ = self->priv->tree_view_1;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp3_, _tmp4_);
	_tmp5_ = self->priv->tree_views;
	_tmp6_ = self->priv->tree_view_2;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp5_, _tmp6_);
	_tmp7_ = self->priv->tree_views;
	_tmp8_ = self->priv->tree_view_3;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp7_, _tmp8_);
	_tmp9_ = self->priv->tree_views;
	_tmp10_ = self->priv->tree_view_4;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp9_, _tmp10_);
	_tmp11_ = gee_array_list_new (gtk_list_store_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	_g_object_unref0 (self->priv->list_stores);
	self->priv->list_stores = _tmp11_;
	_tmp12_ = self->priv->list_stores;
	_tmp13_ = self->priv->list_store_1;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp12_, _tmp13_);
	_tmp14_ = self->priv->list_stores;
	_tmp15_ = self->priv->list_store_2;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp14_, _tmp15_);
	_tmp16_ = self->priv->list_stores;
	_tmp17_ = self->priv->list_store_3;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp16_, _tmp17_);
	_tmp18_ = self->priv->list_stores;
	_tmp19_ = self->priv->list_store_4;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp18_, _tmp19_);
	_tmp20_ = gee_array_list_new (gtk_combo_box_text_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	_g_object_unref0 (self->priv->combo_boxes);
	self->priv->combo_boxes = _tmp20_;
	_tmp21_ = self->priv->combo_boxes;
	_tmp22_ = self->priv->combo_box_1;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp21_, _tmp22_);
	_tmp23_ = self->priv->combo_boxes;
	_tmp24_ = self->priv->combo_box_2;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp23_, _tmp24_);
	_tmp25_ = self->priv->combo_boxes;
	_tmp26_ = self->priv->combo_box_3;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp25_, _tmp26_);
	_tmp27_ = self->priv->combo_boxes;
	_tmp28_ = self->priv->combo_box_4;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp27_, _tmp28_);
	return obj;
}

static void
preferences_dialog_class_init (PreferencesDialogClass * klass,
                               gpointer klass_data)
{
	preferences_dialog_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &PreferencesDialog_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_preferences_dialog_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_preferences_dialog_set_property;
	G_OBJECT_CLASS (klass)->constructor = preferences_dialog_constructor;
	G_OBJECT_CLASS (klass)->finalize = preferences_dialog_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), PREFERENCES_DIALOG_N_WORMS_PROPERTY, preferences_dialog_properties[PREFERENCES_DIALOG_N_WORMS_PROPERTY] = g_param_spec_int ("n-worms", "n-worms", "n-worms", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/org/gnome/Nibbles/ui/preferences-dialog.ui");
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "stack", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, stack));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "headerbar_stack", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, headerbar_stack));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "worm_combobox", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, worm_combobox));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "list_store_1", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, list_store_1));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "list_store_2", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, list_store_2));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "list_store_3", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, list_store_3));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "list_store_4", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, list_store_4));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "tree_view_1", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, tree_view_1));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "tree_view_2", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, tree_view_2));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "tree_view_3", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, tree_view_3));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "tree_view_4", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, tree_view_4));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "combo_box_1", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, combo_box_1));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "combo_box_2", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, combo_box_2));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "combo_box_3", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, combo_box_3));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "combo_box_4", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, combo_box_4));
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "on_worm_change", G_CALLBACK(_preferences_dialog_on_worm_change_gtk_combo_box_changed));
}

static void
preferences_dialog_instance_init (PreferencesDialog * self,
                                  gpointer klass)
{
	self->priv = preferences_dialog_get_instance_private (self);
	gtk_widget_init_template (GTK_WIDGET (self));
}

static void
preferences_dialog_finalize (GObject * obj)
{
	PreferencesDialog * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PREFERENCES_DIALOG, PreferencesDialog);
	_g_object_unref0 (self->priv->settings);
	_g_object_unref0 (self->priv->worm_settings);
	_g_object_unref0 (self->priv->stack);
	_g_object_unref0 (self->priv->headerbar_stack);
	_g_object_unref0 (self->priv->worm_combobox);
	_g_object_unref0 (self->priv->list_store_1);
	_g_object_unref0 (self->priv->list_store_2);
	_g_object_unref0 (self->priv->list_store_3);
	_g_object_unref0 (self->priv->list_store_4);
	_g_object_unref0 (self->priv->tree_view_1);
	_g_object_unref0 (self->priv->tree_view_2);
	_g_object_unref0 (self->priv->tree_view_3);
	_g_object_unref0 (self->priv->tree_view_4);
	_g_object_unref0 (self->priv->combo_box_1);
	_g_object_unref0 (self->priv->combo_box_2);
	_g_object_unref0 (self->priv->combo_box_3);
	_g_object_unref0 (self->priv->combo_box_4);
	_g_object_unref0 (self->priv->list_stores);
	_g_object_unref0 (self->priv->tree_views);
	_g_object_unref0 (self->priv->combo_boxes);
	_g_object_unref0 (self->priv->key_controller);
	G_OBJECT_CLASS (preferences_dialog_parent_class)->finalize (obj);
}

static GType
preferences_dialog_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PreferencesDialogClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) preferences_dialog_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PreferencesDialog), 0, (GInstanceInitFunc) preferences_dialog_instance_init, NULL };
	GType preferences_dialog_type_id;
	preferences_dialog_type_id = g_type_register_static (gtk_window_get_type (), "PreferencesDialog", &g_define_type_info, 0);
	PreferencesDialog_private_offset = g_type_add_instance_private (preferences_dialog_type_id, sizeof (PreferencesDialogPrivate));
	return preferences_dialog_type_id;
}

GType
preferences_dialog_get_type (void)
{
	static volatile gsize preferences_dialog_type_id__volatile = 0;
	if (g_once_init_enter (&preferences_dialog_type_id__volatile)) {
		GType preferences_dialog_type_id;
		preferences_dialog_type_id = preferences_dialog_get_type_once ();
		g_once_init_leave (&preferences_dialog_type_id__volatile, preferences_dialog_type_id);
	}
	return preferences_dialog_type_id__volatile;
}

static void
_vala_preferences_dialog_get_property (GObject * object,
                                       guint property_id,
                                       GValue * value,
                                       GParamSpec * pspec)
{
	PreferencesDialog * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_PREFERENCES_DIALOG, PreferencesDialog);
	switch (property_id) {
		case PREFERENCES_DIALOG_N_WORMS_PROPERTY:
		g_value_set_int (value, preferences_dialog_get_n_worms (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_preferences_dialog_set_property (GObject * object,
                                       guint property_id,
                                       const GValue * value,
                                       GParamSpec * pspec)
{
	PreferencesDialog * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_PREFERENCES_DIALOG, PreferencesDialog);
	switch (property_id) {
		case PREFERENCES_DIALOG_N_WORMS_PROPERTY:
		preferences_dialog_set_n_worms (self, g_value_get_int (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

